# --------------------------------
# gamedata.py
# constantes e tabelas
# --------------------------------

import pyglet
import data

FPS = 60
START_LEVEL = ('0_0.map', (2, 11))
FINAL_LEVEL = ('3_0.map', (2, 13))
#GROUND_Y = 200
GRAVITY = 700
TILE_WIDTH = 32
TILE_HEIGHT = 32
BLOCK = 0   # tipo de tile
PASS = 1    # tipo de tile
SPECIAL = 2 # tipo de tile
BLEND_STANDARD = 0
BLEND_ADDITIVE = 1
FONT_NAME = 'Bitstream Vera Sans'
SCREEN_WIDTH = 640
SCREEN_HEIGHT = 480
BLINK_DURATION = 1.5

LEFT = 65361
UP = 65362
RIGHT = 65363
DOWN = 65364
LEFT_CTRL = 65507

player_hp = 100
player_mp = 100
player_feathers = 0
PLAYER_MAXHP = 100
PLAYER_MAXMP = 100
PLAYER_MAXFEATHERS = 7

entity_set = set()
game_time = 0



animgrid = { }

spritesheet = {
    # nome do spritesheet   :   ( nome do arquivo, no. de quadros na vertical, no. de quadros na horizontal )
    'player'                :   ( 'player.png' , 1 , 2 ),
    'bird'                  :   ( 'bird.png', 1, 2),
    'ball'                  :   ( 'ball.png' , 1 , 1 ),
    'miniball'              :   ( 'miniball.png' , 1 , 1 ),
    'snake'                 :   ( 'snake.png', 1, 4),
    'spikes'                :   ( 'spikes.png', 1, 1),
    'feather'               :   ( 'feather.png', 1, 1),
    'heart'                 :   ( 'heart.png', 1, 1),
    'monster'               :   ( 'monster.png', 1, 3),
    'skull'                 :   ( 'skull.png', 1, 1),
    'drunk'                 :   ( 'drunk.png', 1, 2),
    'boss'                  :   ( 'boss.png', 1, 2),
    'rockguy'               :   ( 'rockguy.png', 1, 3),
    'rock'                  :   ( 'rock.png', 1, 1),
}

animation = {
    # nome da animacao      :   ( spritesheet, lista de quadros, fps, loop? )
    'player_stopped'        :   ( 'player' , [0] , 8 , True ),                      # jogador parado
    'player_walking'        :   ( 'player' , [1,0] , 8 , True ),                    # jogador andando
    'player_jumping'        :   ( 'player' , [1] , 8 , True),                       # jogador pulando
    'bird'                  :   ( 'bird', [0,1], 8, True),                          # passaro
    'ball'                  :   ( 'ball' , [0] , 8 , True ),                        # bola de energia
    'miniball'              :   ( 'miniball', [0], 8, True ),                       # bola pequena
    'snake'                 :   ( 'snake', [0,1,2,3], 8, True),                     # baddie: snake
    'spikes'                :   ( 'spikes' , [0] , 8 , True ),                      # espinhos
    'feather'               :   ( 'feather', [0], 8, True),                         # pena
    'heart'                 :   ( 'heart', [0], 8, True),                           # coracao
    'monster'               :   ( 'monster', [0,1,2,1], 8, True),                   # monstro
    'skull'                 :   ( 'skull', [0], 8, True),                           # caveira
    'drunk'                 :   ( 'drunk', [0,1], 8, True),                         # atirador bebado
    'boss'                  :   ( 'boss', [0,1], 8, True),                          # chefe
    'rockguy'               :   ( 'rockguy', [2,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2], 8, True),   # atirador de pedras
    'rock'                  :   ( 'rock', [0], 8, True),                            # pedra
}





# load_sprites()
# carrega sprites na memoria
def load_sprites():
    for k in animation.keys():
        for w in ('_hflip' , '_vflip' , '_hflip_vflip'):
            animation[k+w] = ( animation[k][0]+w , animation[k][1] , animation[k][2] , animation[k][3] )

    for k in spritesheet.keys():
        f = data.directory(spritesheet[k][0])
        animgrid[k] = pyglet.image.ImageGrid( pyglet.resource.image(f) , spritesheet[k][1] , spritesheet[k][2] ) # pyglet.resource.image(f)
        animgrid[k+'_hflip'] = pyglet.image.ImageGrid( pyglet.resource.image(f,flip_x=True) , spritesheet[k][1] , spritesheet[k][2] )
        animgrid[k+'_vflip'] = pyglet.image.ImageGrid( pyglet.resource.image(f,flip_y=True) , spritesheet[k][1] , spritesheet[k][2] )
        animgrid[k+'_hflip_vflip'] = pyglet.image.ImageGrid( pyglet.resource.image(f,flip_x=True,flip_y=True) , spritesheet[k][1] , spritesheet[k][2] )


