# --------------------------------
# gameover.py
# Tela de gameover
# --------------------------------
from cocos.director import *
from cocos.scene import *
from cocos.scenes import *
from cocos.layer import *
from cocos.sprite import *
from cocos.text import *
from gamedata import *
import pyglet
import sound

# GameOverLayer
# layer da tela de gameover
class GameOverLayer(ColorLayer):

    # __init__()
    # construtor
    def __init__(self):
        super(GameOverLayer, self).__init__(128,0,0,255)
        self.add(Label(text='GAME OVER', font_name=FONT_NAME, font_size=32, x=SCREEN_WIDTH/2, y=SCREEN_HEIGHT/2, anchor_x='center', anchor_y='center'))

        self.timer = 0
        self.unschedule(self.update)
        self.schedule_interval(self.update, 1.0/FPS)
        sound.stop_music()

    # update()
    # atualizacao
    def update(self, dt):
        self.timer += dt
        if self.timer >= 10.0:
            self.on_over()

    # on_over()
    # terminou a tela de gameover
    def on_over(self):
        pyglet.app.exit()


# GameOver
# tela de gameover
class GameOver(Scene):

    # __init__()
    # construtor
    def __init__(self):
        super(GameOver, self).__init__(GameOverLayer())
